	
dig0		equ		0x80
dig1		equ		dig0+1
dig2		equ		dig0+2
dig3		equ		dig0+3
leds		equ		0x84
borro0		equ		0x86
borro1		equ		0x87

sw			equ		0x80
puerto_ff	equ		0x83


.text
start:
	ld sp, 0
	im 1
	ld a, 0
	ld (cnt_isr0), a	; inicializo cuentas en 0 y leds apagados
	ld (cnt_isr1), a
	ld (leds_shadow), a
	out (leds), a
	call hexa7seg
	out (dig0), a
	out (dig1), a
	ld a, 11111110B
	out (borro0), a
	out (borro1), a
	ei
loop:					; loop p. ppal. rota segmento encendido en digito mas significativo del display 
	rlc a
	out (dig3), a
	jp loop
	
	org 0x0038
isr:
	push af
	in a, (puerto_ff)	; leo solicitudes pendientes
	bit 0, a
	jr nz, atiendo0
atiendo1:				; si no solicit perifrico 0 atiendo al 1
	out (borro1), a		; borro FF peticin 1
	ei					; <-- EI aqu, perifrico 0 puede interrumpir a isr1
	call isr1
	pop af
	;ei					; <-- EI aqu, nadie puede interrumpir hasta que se complet isr1
	ret

atiendo0:				; si solicit perifrico 0 lo atiendo
	out (borro0), a		; borro FF peticin 1
	call isr0
	pop af
	ei
	ret
	
isr0:
		; prendo leds[i] sin modificar el resto
	ld a, (leds_shadow)
	set 0, a
	ld (leds_shadow), a
	out (leds), a
		; incremento cuenta y despliego nibble bajo
	ld a, (cnt_isr0)
	inc a
	ld (cnt_isr0), a
	call hexa7seg
	out (dig0), a
		; espero que la llave SW[i] este alta
loop_isr0:
	in a, (sw)
	bit 0, a
	jr z, loop_isr0
		; apago leds[i] sin modificar el resto
	ld a, (leds_shadow)
	res 0, a
	ld (leds_shadow), a
	out (leds), a
	ret

	; atencin al perifrico i=1
isr1:
		; prendo leds[i] sin modificar el resto
	ld a, (leds_shadow)
	set 1, a
	ld (leds_shadow), a
	out (leds), a
		; incremento cuenta y despliego nibble bajo
	ld a, (cnt_isr1)
	inc a
	ld (cnt_isr1), a
	call hexa7seg
	out (dig1), a
		; espero que la llave SW[i] este alta
loop_isr1:
	in a, (sw)
	bit 1, a
	jr z, loop_isr1
		; apago leds[i] sin modificar el resto
	ld a, (leds_shadow)
	res 1, a
	ld (leds_shadow), a
	out (leds), a
	ret

hexa7seg:
		push hl
		push bc
		ld hl, tabla
		and 0x0f
		ld b, 0
		ld c, a
		add hl, bc
		ld a, (hl)
		pop bc
		pop hl
		ret

tabla:
;		b'_gfedcba
	db	01000000B	; 0
	db	01111001B	; 1
	db	00100100B	; 2
	db	00110000B	; 3
	db	00011001B	; 4
	db	00010010B	; 5
	db	00000010B	; 6
	db	01111000B	; 7
	db	00000000B	; 8
	db	00010000B	; 9
	db	00001000B	; A
	db	00000011B	; b
	db	00100111B	; c
	db	00100001B	; d
	db	00000110B	; E
	db	00001110B	; F

cnt_isr0:		db	0		; veces que se atendi perifrico 0
cnt_isr1:		db	0		; veces que se atendi perifrico 1
leds_shadow:	db	0		; copia en memoria de lo escrito en puerto leds

.end
